diff -Nur libmatthew-java-0.7.2/Makefile libmatthew-java-0.7.2_patched/Makefile
--- libmatthew-java-0.7.2/Makefile	2009-04-05 12:46:42.000000000 +0300
+++ libmatthew-java-0.7.2_patched/Makefile	2010-02-28 12:07:15.000000000 +0200
@@ -6,13 +6,12 @@
 CC?=gcc
 LD?=gcc
 JPPFLAGS+=-C -P
-CFLAGS+=-Wall -Os -pedantic -Werror
+CFLAGS+=-Wall -pedantic
 CSTD?=-std=c99
 CSHAREFLAG+=-fpic -fno-stack-protector
 GCJJNIFLAG=-fjni
 JVERCFLAGS+=-source 1.5
 JCFLAGS+=
-INCLUDES+=-I$(JAVA_HOME)/include -I$(JAVA_HOME)/include/linux
 JAVADOCFLAGS?=-quiet -author -link http://java.sun.com/j2se/1.4.2/docs/api/
 
 LDVER?=$(shell ld -v | cut -d' ' -f1)
@@ -20,9 +20,8 @@
 
 ifeq ($(LDVER),GNU)
 LDSHAREFLAGS+=-fpic -shared
-else
-LDSHAREFLAGS+=-lc
 endif
+LDLIBS=-lc
 
 PREFIX?=/usr/local
 JARDIR?=$(PREFIX)/share/java
@@ -62,12 +61,7 @@
 io-$(IOVER).jar: .classes
 	(cd classes; $(JAR) cf ../$@ cx/ath/matthew/io/*class)
 unix-$(UNIXVER).jar: .classes
-ifeq ($(DEBUG),enable)
-	echo "Class-Path: $(JARDIR)/debug-$(DEBUG).jar" > Manifest
-else
-	echo "Class-Path: " > Manifest
-endif
-	(cd classes; $(JAR) cfm ../$@ ../Manifest cx/ath/matthew/unix/*class)
+	(cd classes; $(JAR) cf ../$@ cx/ath/matthew/unix/*class)
 
 hexdump-$(HEXVER).jar: .classes
 	(cd classes; $(JAR) cf ../$@ cx/ath/matthew/utils/Hexdump.class)
@@ -75,7 +69,7 @@
 %.o: %.c %.h
 	$(CC) $(CFLAGS) $(CSTD) $(CSHAREFLAG) $(INCLUDES) -c -o $@ $<
 lib%.so: %.o
-	$(CC) $(LDFLAGS) $(LDSHAREFLAGS) -o $@ $<
+	$(CC) $(LDFLAGS) $(LDSHAREFLAGS) -o $@ $< $(LDLIBS)
 unix-java.h: .classes
 	$(JAVAH) -classpath classes -o $@ cx.ath.matthew.unix.UnixServerSocket cx.ath.matthew.unix.UnixSocket cx.ath.matthew.unix.USInputStream cx.ath.matthew.unix.USOutputStream
 cgi-java.h: .classes
@@ -91,13 +85,11 @@
 	tar zcf $@ libmatthew-java-$(MATTVER)
 
 debug-enable-$(DEBUGVER).jar: cx/ath/matthew/debug/Debug.jpp
-	make .enabledebug
-	echo "Class-Path: $(JARDIR)/hexdump.jar" > Manifest
-	(cd classes;jar cfm ../$@ ../Manifest cx/ath/matthew/debug/*.class)
+	$(MAKE) .enabledebug
+	(cd classes;jar cf ../$@ cx/ath/matthew/debug/*.class)
 debug-disable-$(DEBUGVER).jar: cx/ath/matthew/debug/Debug.jpp
-	make .disabledebug
-	echo "Class-Path: $(JARDIR)/hexdump.jar" > Manifest
-	(cd classes;jar cfm ../$@ ../Manifest cx/ath/matthew/debug/*.class)
+	$(MAKE) .disabledebug
+	(cd classes;jar cf ../$@ cx/ath/matthew/debug/*.class)
 .enabledebug: cx/ath/matthew/debug/Debug.jpp 
 	mkdir -p classes
 	cpp $(PPFLAGS) $(JPPFLAGS) -DDEBUGSETTING=true < cx/ath/matthew/debug/Debug.jpp > cx/ath/matthew/debug/Debug.java
